package com;

import cn.hutool.core.thread.ThreadUtil;
import com.persagy.constant.Constant;
import com.persagy.simulator_gaopin.SimulatorMain_collector;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.web.servlet.ServletComponentScan;
import org.springframework.context.ConfigurableApplicationContext;
import org.springframework.core.env.Environment;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import java.net.InetAddress;
import java.net.UnknownHostException;

@SpringBootApplication
@ServletComponentScan
@Slf4j
public class SimulatorApplication implements ServletContextListener {

    public static void main(String[] args) throws UnknownHostException {

        ConfigurableApplicationContext application = SpringApplication.run(SimulatorApplication.class, args);
        Environment env = application.getEnvironment();
        log.info("\n----------------------------------------------------------\n\t" +
                        "应用 '{}' 运行成功! 访问连接:\n\t" +
                        "Swagger文档: \t\thttp://{}:{}{}{}/doc.html\n\t" +
                        "----------------------------------------------------------",
                env.getProperty("spring.application.name"),
                InetAddress.getLocalHost().getHostAddress(),
                env.getProperty("server.port"),
                env.getProperty("server.servlet.context-path", ""),
                env.getProperty("spring.mvc.servlet.path", ""));
    }

    /**
     * 打印全量日志
     */
    @Value("${iot.log:false}")
    public void setIotLog(boolean value) {
        Constant.iotLog = value;
    }

    @Override
    public void contextInitialized(ServletContextEvent sce) {
        ThreadUtil.execAsync(()->{
            try {
                System.out.println("Constant.iotLog:"+Constant.iotLog);
                SimulatorMain_collector.main(null);
                log.warn("----------SimulatorMain_collector main start--------------");
            } catch (Exception e) {
               log.error(e.getMessage(),e);
            }
        },true);

        log.warn("----------contextInitialize end--------------");
    }
}