package com.persagy.config;

import lombok.Getter;
import lombok.Setter;
import org.springframework.boot.context.properties.ConfigurationProperties;


/**
 * @description:异步线程配置
 * @author:lgy
 * @data:2021/12/28 18:25
 */
@Getter
@Setter
@ConfigurationProperties(AsyncProperties.PREFIX)
public class AsyncProperties {
    public static final String PREFIX = "paas.async";
    private boolean enabled = true;
    /**
     * 异步核心线程数，默认：5
     */
    private int corePoolSize = 5;
    /**
     * 异步最大线程数，默认：50
     */
    private int maxPoolSize = 50;
    /**
     * 队列容量，默认：10000
     */
    private int queueCapacity = 10000;
    /**
     * 线程存活时间，默认：300
     */
    private int keepAliveSeconds = 300;
    /**
     * 线程名前缀
     */
    private String threadNamePrefix = "paas-async-executor-";
}
