package com.persagy.util;

import com.persagy.entity.ValueObject;
import lombok.extern.slf4j.Slf4j;

import java.lang.reflect.Method;
import java.util.Calendar;
import java.util.Date;
@Slf4j
public class FunctionUtil {

	public static ValueObject constant(String constant) {
		ValueObject result = new ValueObject();
		result.type = 1;
		if ("PI".equals(constant)) {
			result.doubleValue = Math.PI;
		} else if ("E".equals(constant)) {
			result.doubleValue = Math.E;
		}
		return result;
	}

	public static ValueObject compute(String function) {
		ValueObject result = new ValueObject();
		result.type = 1;
		Class<?> mathClass = Math.class;
		try {
			Method method = mathClass.getMethod(function, new Class[] {});
			result.doubleValue = (Double) method.invoke(mathClass,
					new Object[] {});
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
		return result;
	}

	public static ValueObject compute(String function, ValueObject a) {
		ValueObject result = new ValueObject();
		result.type = 1;
		double valuea;
		if (a.type == 0) {
			valuea = a.intValue;
		} else {
			valuea = a.doubleValue;
		}
		Class<?> mathClass = Math.class;
		try {
			Method method = mathClass.getMethod(function,
					new Class[] { double.class });
			result.doubleValue = (Double) method.invoke(mathClass,
					new Object[] { valuea });
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
		return result;
	}

	public static ValueObject compute(String function, ValueObject a,
			ValueObject b) {
		ValueObject result = new ValueObject();
		result.type = 1;
		double valuea;
		if (a.type == 0) {
			valuea = a.intValue;
		} else {
			valuea = a.doubleValue;
		}
		double valueb;
		if (b.type == 0) {
			valueb = b.intValue;
		} else {
			valueb = b.doubleValue;
		}
		Class<?> mathClass = Math.class;
		try {
			Method method = mathClass.getMethod(function, new Class[] {
					double.class, double.class });
			result.doubleValue = (Double) method.invoke(mathClass,
					new Object[] { valuea, valueb });
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
		return result;
	}

	public static ValueObject computedate(String function, ValueObject a) {
		ValueObject result = new ValueObject();
		if (a.type == 1) {
			return result;
		}

		Calendar calendar = Calendar.getInstance();
		calendar.setTime(new Date(a.intValue));
		if ("dateyear".equals(function)) {
			result.intValue = calendar.get(Calendar.YEAR);
		} else if ("datemonth".equals(function)) {
			result.intValue = calendar.get(Calendar.MONTH) + 1;
		} else if ("dateday".equals(function)) {
			result.intValue = calendar.get(Calendar.DAY_OF_MONTH);
		} else if ("datedayofweek".equals(function)) {
			result.intValue = calendar.get(Calendar.DAY_OF_WEEK);
		} else if ("datedayofmonth".equals(function)) {
			result.intValue = calendar.get(Calendar.DAY_OF_MONTH);
		} else if ("datedayofyear".equals(function)) {
			result.intValue = calendar.get(Calendar.DAY_OF_YEAR);
		} else if ("datehour".equals(function)) {
			result.intValue = calendar.get(Calendar.HOUR_OF_DAY);
		} else if ("dateminute".equals(function)) {
			result.intValue = calendar.get(Calendar.MINUTE);
		} else if ("datesecond".equals(function)) {
			result.intValue = calendar.get(Calendar.SECOND);
		}
		return result;
	}
}
